<?php
class clsCommon {
	//========================================================================
	// Function Name	:	ComInit
	//------------------------------------------------------------------------
	// Function			:	PHP̽
	// Input			:	Nothing
	// Output			:	Nothing
	// Note				:	եɤ߹ߤǼĤĺPROXY
	//						IP BAN/REFERERΥåԤ
	//========================================================================
	function ComInit($db, $pdb, $board) {
		global $uidlist, $COOKIE, $INFO_COOKIE, $CONFIG;

		$com	= new clsCommon();
		// ꤵƤʤ硢ɽ
		if ( $board == "" ) {
			if ( DEF_SHOW_BOARDLIST == 1 ) {
				require_once("./lib/selectboard.php");
				$selboard = new SelBoard();
				$selboard->SelectBoard($db, $pdb);
				$db->DisConnect();
				exit;
			} else {
				print "<HTML><HEAD>";
				print "<TITLE>".WELCOME_TITLE."</TITLE>";
				print "<BODY>";
				print WELCOME_INFO1;
				print WELCOME_INFO2;
				print "</BODY></HTML>";
				$db->DisConnect();
				exit;
			}
		}

		$this->GetCFG($board);

		// ĺå
		if (1 == $CONFIG['disable'] ){
			$this->ErrorDisp(ERR_CLOSED, $board);
		}

		// PROXYͳå
		if ( 2 == $CONFIG['proxy'] ) {
			require_once("./lib/proxy.php");
			$pr = new clsProxy();
			$accept_flag = $pr->ProxyCheck($db, $pdb);
			if( $accept_flag != 0 ) { $this->ErrorDisp(ERR_PROXY." (Check Code:".$accept_flag.")", $board); }
		}

		// UID
		if ( file_exists(DEF_ULIST) ){
			$fp = fopen(DEF_ULIST, "r");
			while (!feof($fp)) {
				$buffer = trim(fgets($fp, 1024));
			}
			fclose($fp);
			$uidlist = split(":", $buffer);
			if ( !isset($uidlist) ) { $this->CreateUIDList(); }
		} else {
			$this->CreateUIDList();
		}

		$c_id = DEF_COOKIE_ID2.$board;

		if (isset($_COOKIE[$c_id])) {
			$this->GetCookieData($board);
		} else {
			$this->SetCookieData($board,"on");
		}

		$dba	= new clsDBAccess();
		// IP BANREFERERå
		$iRet = $dba->IPCheck($db, $pdb);
		if ( $iRet == 1 ) {
			if ( 1 == $dba->BAN_ReleaseCheck($db, $pdb, $board) ) {
				require_once("./lib/password.php");
				$pcheck = new clsPassEntry();
				$pcheck->InputPassword($board, 0, ERR_HEADDER_REMOTE, ERR_REMOTEHOST1."<B>".$_SERVER['REMOTE_HOST']." ( ".$_SERVER['REMOTE_ADDR']." ) </B><br><br>".ERR_REMOTEHOST2, DEF_BOARD_PHP,"");
			}
			$db->DisConnect();
		} else if ( $iRet == 2 ) {
			$db->DisConnect();
			$com->ErrorDisp(ERR_REFERER, $board);
		}
	}

	//========================================================================
	// Function Name	:	GetCFG
	//------------------------------------------------------------------------
	// Function			:	եɤ߹
	// Input			:	$board		... եɤ߹Ǽ̾
	// Output			:	Nothing
	// Note				:	Globalѿ[$CONFIG][$MenuData]Ͽ
	//========================================================================
	function GetCFG($board) {
		global $CONFIG, $MenuData;
		$filename = "./".DEF_DAT_DIR."/".$board.".cfg";

		$ret = file_exists($filename);
		if ( $ret ) {
			if (!($fp = fopen($filename, "r"))) {
				$this->ErrorDisp("can't open $filename", $board);
			}
			while (!feof($fp)) {
				$buffer = trim(fgets($fp, 2048));
				$param = split("<>", $buffer);
				if ( isset($param[1]) ) {
					$CONFIG[$param[0]] = html_entity_decode($param[1], ENT_QUOTES);
				} else {
					$CONFIG[$param[0]] = "";
				}
			}
			fclose($fp);

			if (1 == $CONFIG['menu_use']){
				$pairs = split("<BR>", $CONFIG['menu_list']);
				foreach ($pairs as $buff) {
					$MenuData[] = $buff;	// ˥塼سǼ
				}
				array_pop($MenuData);		// Ǥ
			}
		} else {
			$this->ErrorDisp("not found $filename", $board);
		}
		return;
	}

	//========================================================================
	// Function Name	:	ErrorDisp
	//------------------------------------------------------------------------
	// Function			:	顼ɽ
	// Input			:	$msg		... 顼å
	//						$board		... 顼ȯǼ̾
	// Output			:	Nothing
	//========================================================================
	function ErrorDisp($msg, $board="") {
		$html = new clsHeadFoot();
		echo $html->DrawHeadder(ERR_HEADDER, 1, 1, 1, $board);
		echo $msg;
		$html->DrawFooter($board);
		exit;
	}

	//========================================================================
	// Function Name	:	ModifyCode
	//------------------------------------------------------------------------
	// Function			:	Ѵ
	// Input			:	$buff		... Ѵʸ
	//						$toDB		... Ѵե饰
	//										true	:Web Encode->DB Encode
	//										false	:DB Encode->Web Encode
	//						$force		...	Ѵե饰
	//										(0:Ѵʤ/1:Ѵ)
	// Output			:	Ѵʸ
	//========================================================================
	function ModifyCode($buff, $toDB, $force) {
		if ( $force == 1 ) {
			if ( $toDB ) { $buff = mb_convert_encoding($buff, DEF_DB_ENCODE, DEF_WEB_ENCODE); } else { $buff = mb_convert_encoding($buff, DEF_WEB_ENCODE, DEF_DB_ENCODE); }
		}
		return $buff;
	}

	//========================================================================
	// Function Name	:	make_seed
	//------------------------------------------------------------------------
	// Function			:	ȯ
	// Input			:	Nothing
	// Output			:	
	//========================================================================
	function make_seed() {
	    list($usec, $sec) = explode(' ', microtime());
	    return (float) $sec + ((float) $usec * 100000);
	}

	//========================================================================
	// Function Name	:	CreateUIDList
	//------------------------------------------------------------------------
	// Function			:	UIDθˤʤʸ
	// Input			:	Nothing
	// Output			:	եؤν
	//						(ե̾DEF_ULISTѤ)
	//========================================================================
	function CreateUIDList() {
		global $uidlist;
		$uidlist = array();
		$randkey = array();

		srand($this->make_seed());
		$basedata = split(":", "0:1:2:3:4:5:6:7:8:9:a:b:c:d:e:f:g:h:i:j:k:l:m:n:o:p:q:r:s:t:u:v:w:x:y:z:A:B:C:D:E:F:G:H:I:J:K:L:M:N:O:P:Q:R:S:T:U:V:W:X:Y:Z:/:+");
		$randkey = array_rand($basedata, count($basedata));
		foreach ( $randkey as $val ) {
			$uidlist[] = $basedata[$val];
		}
		$fno = fopen(DEF_ULIST, 'w');
		foreach($uidlist as $val) {
			fwrite($fno, $val.":");
		}
		fclose($fno);
		chmod(DEF_ULIST, 0707);
	}

	//========================================================================
	// Function Name	:	MakeIPChange
	//------------------------------------------------------------------------
	// Function			:	IPɥ쥹UID(¦)
	// Input			:	$mip		... IPɥ쥹
	// Output			:	UID(¦)ʸ
	//========================================================================
	function MakeIPChange($mip) {
		global $uidlist;
		$aip = split("\.", $mip);
		for ($loop_cnt = 0; $loop_cnt < 4; $loop_cnt++) { 
			$temp[($loop_cnt * 2)] = $uidlist[floor($aip[$loop_cnt] / 4)]; 
			$temp[(($loop_cnt * 2) + 1)] = $uidlist[floor($aip[$loop_cnt] % 64)];
		}
		$retval = $temp[0].$temp[1].$temp[2].$temp[3].$temp[4].$temp[5].$temp[6].$temp[7];
		return $retval;
	}

	//========================================================================
	// Function Name	:	GetHostName
	//------------------------------------------------------------------------
	// Function			:	IPɥ쥹հ
	// Input			:	$ip_address	... հIPɥ쥹
	// Output			:	ۥ̾
	// Note				:	ĶѿꤵƤϡհϹԤʤ
	//========================================================================
	function GetHostName($ip_address) {
		if ( !isset($_SERVER['REMOTE_HOST']) ) {
			$name = @gethostbyaddr($ip_address);
		} else {
			$name = $_SERVER['REMOTE_HOST'];
		}
		return $name;
	}

	//========================================================================
	// Function Name	:	FormatName
	//------------------------------------------------------------------------
	// Function			:	HTML(ϥɥ̾)
	// Input			:	$name		... ϥɥ̾
	//						$tag		... ̾
	//						$rank		... 󥯥ե饰
	//										(0:/1:HN/2:롼)
	//						$trip		... ȥåʸ
	//						$flag		...	HNζĴɽե饰(Def.Off)
	// Output			:	줿HTML
	//========================================================================
	function FormatName($name, $tag, $rank, $trip, $flag="off") {
		$name = $this->ModifyCode($name, False, DEF_CODE_MODIFY);
		$tag = $this->ModifyCode($tag, False, DEF_CODE_MODIFY);

		if ( $name == DEF_ADMIN_NAME && $trip == "" ) {
			$name = "<FONT class=\"adm\">$name [".SH_LABEL_ADMIN."]</FONT>";
		} else {
			if ( $rank != 0 ) {
				if ( $rank == 2 ) {
					$name = "<FONT class=\"sysop\">$name [$tag]</FONT>";
				} else {
					if ( $tag != "" ) { $name = "<FONT class=\"tag\">$name [$tag]</FONT>";
					} else { $name = "<FONT class=\"grn\">$name</FONT>"; }
				}
			} else {
				if ( $trip != "" ) {
					$name = "<FONT class=\"trip\"><B>$name</B></FONT>";
				} else {
					if( $flag == "on" ) { $name = "<FONT class=\"lnk\"><B>$name</B></FONT>"; } else { $name = "$name"; }
				}
			}
		}
		return $name;
	}

	//========================================================================
	// Function Name	:	FormatDateTime
	//------------------------------------------------------------------------
	// Function			:	Ѵ
	// Input			:	$atime		... GMT/CUT 
	//						$flag		... ǯɽե饰(1:ɽ/1ʳ:ɽ)
	// Output			:	Ѵ줿ʸ
	//========================================================================
	function FormatDateTime($atime, $flag) {
		$dow_list = array(LABEL_SUN, LABEL_MON, LABEL_TUE, LABEL_WED, LABEL_THU, LABEL_FRI, LABEL_SAT);
		$dow_index = date("w", $atime);

		if (1 == $flag) {
			$DateStr = date("m/d", $atime);
		} else {
			$DateStr = date("Y/m/d", $atime);
		}
		$DateStr .= " (".$dow_list[$dow_index].") ";
		$DateStr .= date("H:i", $atime);

		return $DateStr;
	}

	//========================================================================
	// Function Name	:	FormatComment
	//------------------------------------------------------------------------
	// Function			:	
	// Input			:	$com		... 
	//						$name		... ƼHN
	// Output			:	줿
	// Note				:	ͤΤ߰Ѳǽ
	//========================================================================
	function FormatComment($com, $name) {
		global $CONFIG;

		$com = $this->ModifyCode($com, False, DEF_CODE_MODIFY);
		$name = $this->ModifyCode($name, False, DEF_CODE_MODIFY);

		$com = "<P>$com</P>";

	    $com = ereg_replace("(^|>)(&gt;[^<]*)", "\\1<FONT COLOR=".$CONFIG['color_quote'].">\\2</font>", $com);
		$com = eregi_replace("(https?|ftp|news)(://[[:alnum:]\S\+\$\?\.%,!#~*/:@&=_-]+)","<a href=\"\\1\\2\" target=\"_blank\">\\1\\2</a>", $com);
		if ( $name == DEF_ADMIN_NAME ) {
		    $com = eregi_replace("(&lt;B&gt;)", "<B>", $com);
		    $com = eregi_replace("(&lt;\/B&gt;)", "</B>", $com);
		    $com = eregi_replace("(&lt;U&gt;)", "<U>", $com);
		    $com = eregi_replace("(&lt;\/U&gt;)", "</U>", $com);
		    $com = eregi_replace("(&lt;UL&gt;)", "<UL>", $com);
		    $com = eregi_replace("(&lt;\/UL&gt;)", "</UL>", $com);
		    $com = eregi_replace("(&lt;LI&gt;)", "<LI>", $com);
		    $com = eregi_replace("(&lt;\/LI&gt;)", "</LI>", $com);
		    $com = eregi_replace("(&lt;EM&gt;)", "<EM>", $com);
		    $com = eregi_replace("(&lt;\/EM&gt;)", "</EM>", $com);
		    $com = eregi_replace("(&lt;HR&gt;)", "<HR>", $com);
		}

		return $com;
	}

	//========================================================================
	// Function Name	:	MakeLink
	//------------------------------------------------------------------------
	// Function			:	HTML
	// Input			:	$board		... ΤǼ̾
	//						$act		... 
	//										(new:/reply:ֿ/edit:Խ)
	//										(fin:λ/revive:)
	//										(del:/delcancel:)
	//						$msg		...	󥯤ɽʸ
	//						$num		...	ֹ
	//						$subact		...	lparamꤹʸ
	// Output			:	HTML
	//========================================================================
	function MakeLink($board, $act, $msg, $num, $subact) {
		$buff = "<A HREF=\"";
		if( $act == 'new' || $act == 'reply' || $act == 'reply2' || $act == 'edit' ) {	$buff .= DEF_INPUT_PHP;
		} else if ( $act == "fin" || $act == "revive" ) {			$buff .= DEF_FINISH_PHP;
		} else if ( $act == "delete" || $act == "delcancel" ) {		$buff .= DEF_DELETE_PHP;
		}
		$buff .= "?board=".$board."&cmd=$act";
		if ( $subact ) { $buff .= "&lparam=$subact"; };
		$buff .= "&wparam=$num\">$msg</A>";

		return $buff;
	}

	//========================================================================
	// Function Name	:	SetCookieData
	//------------------------------------------------------------------------
	// Function			:	Cookie¸
	// Input			:	$board		... ¸Ǽ̾
	//						$viewcheck	... ɥåCookie¸ե饰
	//										(off:¸ʤ/offʳ:¸)
	// Output			:	Nothing
	//========================================================================
	function SetCookieData($board, $viewcheck) {
		global $COOKIE, $INFO_COOKIE;

		if ( $viewcheck != "off" ) {
			$lastview = time();
			$COOKIE['lastview'] = $lastview;
		}
		if ($COOKIE['kindselect'] == "" ) {
			$COOKIE['kindselect'] = HEADDER_COMBO_ALLKIND;
		}
		if ($COOKIE['finselect'] == "" ) {
			$COOKIE['finselect'] = DEF_FIN_SHOW;
		}

		$expire = time() + 365*24*3600;
		$cook = "name<".$COOKIE['name'].">hp<".$COOKIE['hp'].">email<".$COOKIE['email'].">icq<".$COOKIE['icq'].">password<".$COOKIE['password'].">sort<".$COOKIE['sort'].">uid<".$COOKIE['uid'].">lastview<".$COOKIE['lastview'].">";
		$cook1 = "kindselect<".$COOKIE['kindselect'].">";
		$cook1 .= "finselect<".$COOKIE['finselect'].">";
		$cook1 .= "disp<".$COOKIE['disp'].">";

		$cook2 = "last<".$INFO_COOKIE['last'].">reply<".$INFO_COOKIE['reply'].">";

		setcookie(DEF_COOKIE_ID, $cook, $expire);

		$c_id = DEF_COOKIE_ID2.$board;
		if ( DEF_EASY_INFO == 1 ) {
			setcookie($c_id, $cook1.$cook2, $expire);
		} else {
			setcookie($c_id, $cook1, $expire);
		}
	}

	//========================================================================
	// Function Name	:	GetCookieData
	//------------------------------------------------------------------------
	// Function			:	Cookie
	// Input			:	$board		... Ǽ̾
	// Output			:	Nothing
	//========================================================================
	function GetCookieData($board) {
		global $COOKIE, $INFO_COOKIE;

		$cookie_list = array();
		$dummy = array();
		$cookie_list = split(">",$_COOKIE[DEF_COOKIE_ID]);
		foreach ( $cookie_list as $buff ) {
			$dummy = split("<", $buff);
			if ( isset($dummy[1]) ) {
				$COOKIE[$dummy[0]] = $dummy[1];
			} else {
				$COOKIE[$dummy[0]] = "";
			}
		}
		$cookie_list = array();
		$dummy = array();
		$cbuff = "";
		$cookie_list = split(">",$_COOKIE[DEF_COOKIE_ID2.$board]);
		foreach ( $cookie_list as $buff ) {
			$dummy = split("<", $buff);
			if ( isset($dummy[1]) ) { $cbuff = $dummy[1]; } else { $cbuff = ""; }
			if ( $dummy[0] == "kindselect" || $dummy[0] == "finselect" || $dummy[0] == "disp" ) {
				$COOKIE[$dummy[0]] = $cbuff;
			} else {
				$INFO_COOKIE[$dummy[0]] = $cbuff;
			}
		}
	}

	//========================================================================
	// Function Name	:	IsNew
	//------------------------------------------------------------------------
	// Function			:	Newɽ
	// Input			:	$t			... GMT/CUT 
	// Output			:	$CONFIG['flush_time']꿷
	//						NewɽHTML֤
	//========================================================================
	function IsNew($t) {
		global $CONFIG;
		$icon = "";
		$n_time = time();

		if ( (($n_time - $t)/3600) < $CONFIG['flush_time']) {
			$icon = "<IMG SRC=\"".DEF_ICON_NEW."\" BORDER=0 ALT=\"New\">";
		}
		return $icon;
	}

	//========================================================================
	// Function Name	:	DecordLineFeed
	//------------------------------------------------------------------------
	// Function			:	ʸѴ
	// Input			:	$dat		... Ѵʸ
	//						$mode		... Ѵե饰
	//										(0:Ԥ/0ʳ:<BR>Ѵ)
	// Output			:	Ѵ줿ʸ
	//========================================================================
	function DecordLineFeed($dat, $mode) {
		$retval = $dat;
		$retval = str_replace("\r\n","\n", $retval);
		if ( $mode == 0 ) {
			$retval = preg_replace ("/\r|\n/", "", $retval);
		} else {
			$retval = preg_replace ("/\r|\n/", "<BR>", $retval);
		}
		return $retval;
	}

	//========================================================================
	// Function Name	:	User_Agent
	//------------------------------------------------------------------------
	// Function			:	֥饦OS
	// Input			:	Nothing
	// Output			:	󤬳Ǽ줿Ϣ֤
	//						platform	:ץåȥե
	//						platform_v	:嵭С
	//						browser		:ѥ֥饦
	//						browser_v	:֥饦С
	//========================================================================
	function User_Agent() {
		$user_agent = $_SERVER['HTTP_USER_AGENT'];
		if( preg_match("/^Mozilla\/.+\(compatible\; MSIE .+\;.+\)/", $user_agent, $buff) ) {
			if( preg_match("/NetCaptor ([0-9\.]+)/", $user_agent) ) {
				$browser = 'NetCaptor';
				$browser_v = $buff[1];
			} else if( preg_match("/Opera ([0-9\.]+)/", $user_agent, $buff) ) {
				$browser = 'Opera';
				$browser_v = $buff[1];
			} else {
				$browser = 'InternetExplorer';
				if( preg_match("/MSIE\s?([0-9]+)\.([0-9]+)/i",$user_agent,$buff) ) {
					$browser_v = $buff[1].".".$buff[2];
				}
			}
			if( preg_match("/Windows 3\.1/i", $user_agent) ) {
				$platform = 'Windows';
				$platform_v = '3.1';
			} else if( preg_match("/Win32/i", $user_agent) ) {
				$platform = 'Windows';
				$platform_v = '32';
			} else if( preg_match("/Windows 95/i", $user_agent) ) {
				$platform = 'Windows';
				$platform_v = '95';
			} else if( preg_match("/Windows 98/i", $user_agent) ) {
				$platform = 'Windows';
				if( preg_match("/Win 9x 4\.90/", $user_agent) ) {
					$platform_v = 'Me';
				} else {
					$platform_v = '98';
				}
			} else if( preg_match("/Windows NT 5\.0/i", $user_agent) ) {
				$platform = 'Windows';
				$platform_v = '2000';
			} else if( preg_match("/Windows NT 5\.1/i", $user_agent) ) {
				$platform = 'Windows';
				$platform_v = 'XP';
			} else if( preg_match("/Windows NT/i", $user_agent) 
					&&  !preg_match("/Windows NT 5\.0/i", $user_agent) ) {
				$platform = 'Windows';
				$platform_v = 'NT';
			} else if( preg_match("/Windows CE/i", $user_agent) ) {
				$platform = 'Windows';
				$platform_v = 'CE';
			} else if( preg_match("/Mac/i", $user_agent) ) {
				$platform = 'MacOS';
				if( preg_match("/Mac_68000/i", $user_agent) ) {
					$platform_v = '68K';
				} else if( preg_match("/Mac_PowerPC/i", $user_agent) ) {
					$platform_v = 'PowerPC';
				}
			} else if( preg_match("/WebTV/i", $user_agent) ) {
				$platform = 'WebTV';
				$buff2 = str_replace(" ", "", $user_agent);
				$buff3 = str_replace("/", "", $buff2[1]);

				$platform_v = $buff3[1];
			} else {
				$platform = '';
				$platform_v = '';
			}
		} else if( preg_match("/^Mozilla\/([0-9\.]+).*\(.+\; [NIU]/", $user_agent, $buff) ) {
			$browser = 'NetscapeNavigator';
			$browser_v = $buff[1];

			if( preg_match("/Win95/", $user_agent) ) {
				$platform = 'Windows';
				$platform_v = '95';
			} else if( preg_match("/Win 9x 4\.90/i", $user_agent) ) {
				$platform = 'Windows';
				$platform_v = 'Me';
			} else if( preg_match("/Win98/i", $user_agent) ) {
				$platform = 'Windows';
				$platform_v = '98';
			} else if( preg_match("/WinNT/i", $user_agent) ) {
				$platform = 'Windows';
				$platform_v = 'NT';
			} else if( preg_match("/Windows NT 5\.0/i", $user_agent) ) {
				$platform = 'Windows';
				$platform_v = '2000';
			} else if( preg_match("/Macintosh/i", $user_agent) ) {
				$platform = 'MacOS';
				if( preg_match("/68K/i", $user_agent) ) {
					$platform_v = '68K';
				} else if( preg_match("/PPC/i", $user_agent) ) {
					$platform_v = 'PowerPC';
				}
			} else if( preg_match("/SunOS/i", $user_agent) ) {
				$platform = 'SunOS';
				$buff2 = preg_split ("/\;/", $user_agent);
				$buff3 = preg_split ("/ /", $buff2[2]);
				$platform_v = $buff3[2];
			} else if( preg_match("/Linux/i", $user_agent) ) {
				$platform = 'Linux';
				$buff2 = preg_split ("/ /", $user_agent);
				$flag = 0;
				foreach ( $buff2 as $val ) {
					if($flag) {
						$platform_v = $val;
						break;
					}
					if( preg_match("/^Linux$/i", $val) ) { $flag = 1; };
				}
			} else if( preg_match("/FreeBSD/i", $user_agent) ) {
				$platform = 'FreeBSD';
				$buff2 = preg_split ("/ /", $user_agent);
				$flag = 0;
				foreach ( $buff2 as $val ) {
					if($flag) {
						$platform_v = $val;
						break;
					}
					if( preg_match("/^FreeBSD$/i", $val) ) { $flag = 1; };
				}
			} else if( preg_match("/NetBSD/i", $user_agent) ) {
				$platform = 'NetBSD';
				$platform_v = '';
			} else if( preg_match("/AIX/i", $user_agent) ) {
				$platform = 'AIX';
				$platform_v = '';
			} else if( preg_match("/IRIX/i", $user_agent) ) {
				$platform = 'IRIX';
				$buff2 = preg_split ("/ /", $user_agent);
				$flag = 0;
				foreach ( $buff2 as $val ) {
					if($flag) {
						$platform_v = $val;
						break;
					}
					if( preg_match("/^IRIX$/i", $val) ) { $flag = 1; };
				}
			} else if( preg_match("/HP-UX/i", $user_agent) ) {
				$platform = 'HP-UX';
				$platform_v = '';
			} else if( preg_match("/OSF1/i", $user_agent) ) {
				$platform = 'OSF1';
				$buff2 = preg_split ("/ /", $user_agent);
				$flag = 0;
				foreach ( $buff2 as $val ) {
					if($flag) {
						$platform_v = $val;
						break;
					}
					if( preg_match("/^OSF1$/i", $val) ) { $flag = 1; };
				}
			} else {
				$platform = '';
				$platform_v = '';
			}
		} else {
			$platform = '';
			$platform_v = '';
			$browser = '';
			$browser_v = '';
		}
		$retval = array("platform"=>$platform, "platform_v"=>$platform_v, "browser"=>$browser, "browser_v"=>$browser_v);
		return $retval;
	}

	//========================================================================
	// Function Name	:	SearchBold
	//------------------------------------------------------------------------
	// Function			:	Ĵɽ
	// Input			:	$org_str	...	оʸ
	//						$search_str	... ʸ
	// Output			:	Ĵդʸ
	// Note				:	$search_strξϤΤޤ֤
	//========================================================================
	function SearchBold($org_str, $search_str) {
		$rep_str = $org_str;
		if ( $search_str != "" ) {
			$search_str = $this->ModifyCode($search_str, True, DEF_CODE_MODIFY);
			$rep_str	= $this->ModifyCode($rep_str, True, DEF_CODE_MODIFY);
			$search_str = htmlspecialchars($search_str, ENT_NOQUOTES);

			if ( get_magic_quotes_gpc()==1 ) {
				$search_str = stripslashes($search_str);
			}

			$rep_str	= str_replace($search_str, "<u><em>".$search_str."</em></u>", $rep_str);
			$rep_str	= $this->ModifyCode($rep_str, False, DEF_CODE_MODIFY);
		}
		return $rep_str;
	}

	//========================================================================
	// Function Name	:	QuotesEntities
	//------------------------------------------------------------------------
	// Function			:	QuotesѴ
	// Input			:	$str		...	оʸ
	// Output			:	Ѵʸ
	//========================================================================
	function QuotesEntities($str) {
		$buff = $str;
		$buff = str_replace("\"", "&quot;", $buff);
		$buff = str_replace("'", "&#039;", $buff);
		return $buff;
	}

	//========================================================================
	// Function Name	:	PostData
	//------------------------------------------------------------------------
	// Function			:	Formʸμ
	// Input			:	$chk		...	եॳȥ̾
	//						$def		...	̤ϤξΥǥեʸ
	// Output			:	եफ줿ʸ
	//========================================================================
	function PostData($chk, $def) {
		$buff = $def;
		if ( isset($_POST[$chk]) && trim($_POST[$chk]) != "" ) { $buff = $_POST[$chk]; }
		$buff = htmlspecialchars($buff, ENT_QUOTES);
		return $buff;
	}
}
?>
